import csv
from time import sleep

from data.sig_ref import SIGRef
from providers.sigrefdata.file_download_sig_ref_data_provider import FileDownloadSIGRefDataProvider


class MOTA(FileDownloadSIGRefDataProvider):
    """SIG ref data provider for Mills on the Air"""

    POLL_INTERVAL_DAYS = 30
    SIG = "MOTA"
    DATA_URL = "https://www.gma.rocks/download/mills.csv"

    def __init__(self, provider_config):
        super().__init__(self.SIG, provider_config, self.DATA_URL, self.POLL_INTERVAL_DAYS)

    def _http_response_to_data(self, http_response):
        new_data = []
        for row in csv.DictReader(http_response.content.decode("utf-8-sig").splitlines()[1:]):
            ref_id = row["Reference"]
            new_data.append(SIGRef(sig=self.SIG, id=ref_id, name=row["Name"] if "Name" in row else None,
                                      ref_type="Mill",
                                      url="https://www.cqgma.org/zinfo.php?ref=" + ref_id,
                                      latitude=float(row["Latitude"]) if "Latitude" in row and row[
                                          "Latitude"] != "" else None,
                                      longitude=float(row["Longitude"]) if "Longitude" in row and row[
                                          "Longitude"] != "" else None,
                                      grid=row["Maidenhead Locator"]))

            # Bail out if a stop has been requested, i.e. the program is shutting down - no need to parse the rest of
            # the data in this case
            if self._stop_event.is_set():
                break

            # Very short pause. This will extend the time to handle sig refs by a few seconds but will ensure some time
            # is available for other threads e.g. the web server.
            sleep(0.001)

        return new_data
